Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading

Namespace NorthwindLibrary
	Public Class ContextFactory
		Public Shared Function ObtainContext() As NorthwindOAEntityDiagrams
			Dim context As NorthwindOAEntityDiagrams = Nothing

			Dim key As String = Thread.CurrentContext.ContextID.ToString()

			Dim slot As LocalDataStoreSlot = Thread.GetNamedDataSlot(key)
			If Not slot Is Nothing Then
				context = CType(Thread.GetData(slot), NorthwindOAEntityDiagrams)
			End If
			If context Is Nothing Then
				context = New NorthwindOAEntityDiagrams()
				If slot Is Nothing Then
					slot = Thread.AllocateNamedDataSlot(key)
				End If
				Thread.SetData(slot, context)
			End If
			Return context

		End Function
	End Class
End Namespace
